import 'package:yona/yona.dart';
import 'dart:math' as math;

var host = NetAddr.fromString("yonafediverse.com:7777");//rabin //german

void main() async {
  var user1 = await Crypto.genSK();
  var user2 = await Crypto.genSK();
  var packet = Packet(Crypto.derivePK(user1), Crypto.derivePK(user2),
      await Crypto.randBytes(100), Packet.zeroID);
  var zeroPacket = Packet(Crypto.derivePK(user1), List.filled(Packet.pkSize, 0), [],
      Packet.zeroID);
  List<Packet> packets = [zeroPacket];
  var timings = [];
  for (var i = 0; i < 10; i++) {
    var startSend = DateTime.now().millisecondsSinceEpoch;
    await Longlog.push(host, packet, user1, Duration(seconds: 2));
    var endSend = DateTime.now().millisecondsSinceEpoch;
    var startRecv = DateTime.now().millisecondsSinceEpoch;
    packets = await Longlog.pull(host, zeroPacket, 10);
    var endRecv = DateTime.now().millisecondsSinceEpoch;
    assert(packets.length == math.min(i+1,10));
    for (var pack in packets) {
      assert(Utils.equal(pack.data, packet.data));
      assert(Utils.equal(pack.from, packet.from));
      assert(Utils.equal(pack.to, packet.to));
    }
    timings.add({
      "send": endSend - startSend,
      "recv": endRecv - startRecv,
    });
    print(i);
  }
  print(
      "send ${timings.map((e) => e["send"]).reduce((value, element) => value + element) / 1000}");
  print(
      "recv ${timings.map((e) => e["recv"]).reduce((value, element) => value + element) / 1000}");
}
